//R}hRg[[ ver0.1 by 
#include <windows.h>
#include "FTD2XX.H"

#define SEND_BUTTON_ID 1
#define RESET_BUTTON_ID 2
#define TOTAL_FRAME_N 300
#define PAD_BUTTON0 0xfe
#define PAD_BUTTON1 0xfd
#define PAD_BUTTON2 0xfb
#define PAD_BUTTON3 0xf7
#define PAD_BUTTON4 0xef
#define PAD_BUTTON5 0xdf
#define PAD_BUTTON6 0xbf
#define PAD_BUTTON7 0x7f

FT_HANDLE hFt1;
FT_HANDLE hFt2;
WNDPROC DefPadButtonProc;
HWND hcheck[ TOTAL_FRAME_N ][ 16 ];
HWND hpadbutton[ 16 ];
HWND hscrwnd;

//Е̃Rg[[ɃR}h𑗐M֐
void Send_Command1( int device_n , BYTE command ){
	DWORD dwWritten;

	if( device_n == 1 ){
		FT_Write( hFt1 , &command , 1 , &dwWritten );
	}
	else{
		FT_Write( hFt2 , &command , 1 , &dwWritten );
	}
}

//̃Rg[[ɃR}h𑗐M֐
void Send_Command2( BYTE command1 , BYTE command2 ){
	DWORD dwWritten;

	FT_Write( hFt1 , &command1 , 1 , &dwWritten );
	FT_Write( hFt2 , &command2 , 1 , &dwWritten );
}

//XN[EBhẼvV[W
LRESULT CALLBACK ScrWndProc( HWND hwnd , UINT msg , WPARAM wp , LPARAM lp ){
	static SCROLLINFO scr;
	int dy;

	switch( msg ){
	case WM_CREATE:
		//XN[o[̏ݒ肷
		scr.cbSize = sizeof( SCROLLINFO );
		scr.fMask = SIF_PAGE | SIF_POS | SIF_RANGE;
		scr.nMin = 0;
		scr.nMax = TOTAL_FRAME_N - 1;
		scr.nPage = 20;
		return 0;
	case WM_LBUTTONDOWN:
		SetFocus( hscrwnd );
		return 0;
	case WM_VSCROLL:
		//XN[
		switch( LOWORD( wp ) ){
		case SB_LINEUP:
			if( scr.nPos ){
				dy = 1;
				scr.nPos--;
			}
			break;
		case SB_LINEDOWN:
			if( scr.nPos < scr.nMax - 19 ){
				dy = -1;
				scr.nPos++;
			}
			break;
		case SB_PAGEUP:
			if( scr.nPos - 20 > scr.nMin ){
				dy = 20;
				scr.nPos -= scr.nPage;
			}
			else{
				dy = scr.nPos;
				scr.nPos = scr.nMin;
			}
			break;
		case SB_PAGEDOWN:
			if( scr.nPos + 20 < scr.nMax - 19 ){
				dy = -20;
				scr.nPos += scr.nPage;
			}
			else{
				dy = scr.nPos - ( scr.nMax - 19 );
				scr.nPos = scr.nMax - 19;
			}
			break;
		case SB_THUMBTRACK:
			dy = scr.nPos - HIWORD( wp );
			scr.nPos = HIWORD( wp );
			break;
		}
		SetScrollInfo( hscrwnd , SB_VERT , &scr , TRUE );
		ScrollWindow( hscrwnd , 0 , dy * scr.nPage , NULL , NULL );
		return 0;
	}
	return DefWindowProc( hwnd , msg , wp , lp );
}

//pbh{^̃vV[W
LRESULT CALLBACK PadButtonProc( HWND hwnd , UINT msg , WPARAM wp , LPARAM lp ){
	BYTE command;
	int button_n;
	int device_n;

	CallWindowProc( DefPadButtonProc , hwnd , msg , wp , lp );
	switch( msg ){
	case WM_LBUTTONDOWN:
		for(button_n=0;button_n<16;button_n++){
			if( GetFocus() == hpadbutton[ button_n ] ){
				device_n = button_n < 8 ? 1 : 2;
				command = button_n < 8 ? 0x01 << button_n : 0x01 << ( button_n - 8 );
				command ^= 0xff;
				Send_Command1( device_n , command );
			}
		}
		return 0;
	case WM_LBUTTONUP:
		Send_Command2( 0xff , 0xff );
		return 0;
	}
	return CallWindowProc( DefPadButtonProc , hwnd , msg , wp , lp );
}

//CEBhẼvV[W
LRESULT CALLBACK MainWndProc( HWND hwnd , UINT msg , WPARAM wp , LPARAM lp ){
	FT_STATUS status;
	LONGLONG start_count;
	LONGLONG frequency;
	LONGLONG now_count;
	HANDLE hprocess;
	DWORD rate = 96000;
	BYTE command[ 2 ][ TOTAL_FRAME_N ];
	int last_frame = 0;
	int button_n;
	int frame_n;

	switch( msg ){
	case WM_DESTROY:
		Send_Command2( 0xff , 0xff );
		FT_ResetDevice( hFt1 );
		FT_ResetDevice( hFt2 );
		FT_Close( hFt1 );
		FT_Close( hFt2 );
		PostQuitMessage(0);
		return 0;
	case WM_CREATE:
		//foCX1I[v
		status = FT_OpenEx( "FT000001" , FT_OPEN_BY_SERIAL_NUMBER , &hFt1 );
		if( status == FT_OK ){
			FT_ResetDevice( hFt1 );
			FT_SetBitMode( hFt1 , 0xff , 1 );
			FT_SetBaudRate( hFt1 , rate );
		}
		else{
			MessageBox( hwnd , TEXT( "foCX1Fł܂" ) , TEXT( "Device1 Open" ) , MB_OK );
		}
		//foCX2I[v
		status = FT_OpenEx( "FT000002" , FT_OPEN_BY_SERIAL_NUMBER , &hFt2 );
		if( status == FT_OK ){
			FT_ResetDevice( hFt2 );
			FT_SetBitMode( hFt2 , 0xff , 1 );
			FT_SetBaudRate( hFt2 , rate );
		}
		else{
			MessageBox( hwnd , TEXT( "foCX2Fł܂" ) , TEXT( "Device2 Open" ) , MB_OK );
		}
		Send_Command2( 0xff , 0xff );
		return 0;
	case WM_COMMAND:
		switch( LOWORD( wp ) ){
		case SEND_BUTTON_ID:
			//vZX̗D揇ʂグ
			hprocess = OpenProcess( PROCESS_SET_INFORMATION , TRUE , GetCurrentProcessId() );
			if( hprocess == NULL ) return 0;
			SetPriorityClass( hprocess , HIGH_PRIORITY_CLASS );
			//R}hM
			for(frame_n=0;frame_n<TOTAL_FRAME_N;frame_n++){
				command[ 0 ][ frame_n ] = 0x00;
				for(button_n=0;button_n<8;button_n++){
					if( SendMessage( hcheck[ frame_n ][ button_n ] , BM_GETCHECK , 0 , 0 ) ){
						command[ 0 ][ frame_n ] |= ( 0x01 << button_n );
						last_frame = frame_n;
					}
				}
				command[ 0 ][ frame_n ] ^= 0xff;
				command[ 1 ][ frame_n ] = 0x00;
				for(button_n=8;button_n<16;button_n++){
					if( SendMessage( hcheck[ frame_n ][ button_n ] , BM_GETCHECK , 0 , 0 ) ){
						command[ 1 ][ frame_n ] |= ( 0x01 << ( button_n - 8 ) );
						last_frame = frame_n;
					}
				}
				command[ 1 ][ frame_n ] ^= 0xff;
			}
			Sleep( 1000.0 / 60 );
			QueryPerformanceFrequency( (LARGE_INTEGER *)&frequency );
			QueryPerformanceCounter( (LARGE_INTEGER *)&start_count );
			for(frame_n=0;frame_n<=last_frame;frame_n++){
				Sleep( 10 );
				while( 1 ){
					QueryPerformanceCounter( (LARGE_INTEGER *)&now_count );
					if( ( ( now_count - start_count ) * 1000000 ) / frequency > 1000000.0 / 60 ){
						QueryPerformanceCounter( (LARGE_INTEGER *)&start_count );
						break;
					}
				}
				Send_Command2( command[ 0 ][ frame_n ] , command[ 1 ][ frame_n ] );
			}
			Sleep( 1000.0 / 60 );
			Send_Command2( 0xff , 0xff );
			FT_ResetDevice( hFt1 );
			FT_ResetDevice( hFt2 );
			//vZX̗D揇ʂɖ߂
			SetPriorityClass( hprocess , NORMAL_PRIORITY_CLASS );
			break;
		case RESET_BUTTON_ID:
			//Zbg
			for(frame_n=0;frame_n<TOTAL_FRAME_N;frame_n++){
				for(button_n=0;button_n<16;button_n++){
					SendMessage( hcheck[ frame_n ][ button_n ] , BM_SETCHECK , BST_UNCHECKED , 0 );
				}
			}
			Send_Command2( 0xff , 0xff );
			FT_ResetDevice( hFt1 );
			FT_ResetDevice( hFt2 );
			break;
		}
		return 0;
	}
	return DefWindowProc( hwnd , msg , wp , lp );
}

int WINAPI WinMain( HINSTANCE hInstance , HINSTANCE hPrevInstance , PSTR lpCmdLine , int nCmdShow ){
	WNDCLASS winc;
	HANDLE hmutex;
	LPTSTR lptStr;
	TCHAR str;
	HWND hwnd;
	MSG msg;
	int button_n;
	int frame_n;

	//dNh~
	hmutex = CreateMutex( NULL , TRUE , "mutexCMMACON" );
	if( !hmutex ) return 0;
	if( GetLastError() == ERROR_ALREADY_EXISTS ){
		hwnd = FindWindow( "classCOMMACON" , NULL );
		if( hwnd ){
			if(IsIconic( hwnd ) ) ShowWindow( hwnd , SW_RESTORE );
			SetForegroundWindow( hwnd );
		}
		return 0;
	}
	//CEBhẼNXo^
	winc.style = CS_HREDRAW | CS_VREDRAW;
	winc.lpfnWndProc = MainWndProc;
	winc.cbClsExtra = winc.cbWndExtra = 0;
	winc.hInstance = hInstance;
	winc.hIcon = LoadIcon( hInstance , TEXT( "COMMACON_ICON" ) );
	winc.hCursor = LoadCursor( NULL , IDC_ARROW );
	winc.hbrBackground = (HBRUSH)GetStockObject( WHITE_BRUSH );
	winc.lpszMenuName = NULL;
	winc.lpszClassName = TEXT( "classCOMMACON" );
	if( !RegisterClass( &winc ) ) return -1;
	//CEBhE
	hwnd = CreateWindow(
			TEXT( "classCOMMACON" ) , TEXT( "R}hRg[[" ) ,
			WS_VISIBLE | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX ,
			CW_USEDEFAULT , CW_USEDEFAULT ,
			550 , 560 ,
			NULL , NULL ,
			hInstance , NULL
	);
	if( hwnd == NULL ) return -1;
	//CEBhE̔wi
	CreateWindow(
		TEXT( "STATIC" ) , NULL ,
		WS_CHILD | WS_VISIBLE ,
		0 , 0,
		550 , 560 ,
		hwnd , NULL , hInstance , NULL
	);
	//1Rx
	CreateWindow(
		TEXT( "STATIC" ) , TEXT( "Rg[[1" ) ,
		WS_CHILD | WS_VISIBLE | SS_CENTER ,
		52 , 22 ,
		160 , 20 ,
		hwnd , NULL , hInstance , NULL
	);
	//2Rx
	CreateWindow(
		TEXT( "STATIC" ) , TEXT( "Rg[[2" ) ,
		WS_CHILD | WS_VISIBLE | SS_CENTER ,
		222 , 22 ,
		160 , 20 ,
		hwnd , NULL , hInstance , NULL
	);
	//pbh{^x
	for(button_n=0;button_n<16;button_n++){
		switch( button_n ){
		case 0:
		case 8:
			lptStr = TEXT("");
			break;
		case 1:
		case 9:
			lptStr = TEXT("");
			break;
		case 2:
		case 10:
			lptStr = TEXT("");
			break;
		case 3:
		case 11:
			lptStr = TEXT("");
			break;
		case 4:
		case 12:
			lptStr = TEXT("");
			break;
		case 5:
		case 13:
			lptStr = TEXT("~");
			break;
		case 6:
		case 14:
			lptStr = TEXT("");
			break;
		case 7:
		case 15:
			lptStr = TEXT("");
			break;
		}
		CreateWindow(
			TEXT( "STATIC" ) , lptStr ,
			WS_CHILD | WS_VISIBLE | SS_CENTER ,
			button_n < 8 ? button_n * 20 + 52 : button_n * 20 + 62 , 45 ,
			20 , 20 ,
			hwnd , NULL , hInstance , NULL
		);
	}
	//pbh{^
	for(button_n=0;button_n<16;button_n++){
		hpadbutton[ button_n ] = CreateWindow(
			TEXT( "BUTTON" ) , NULL ,
			WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON ,
			button_n < 8 ? button_n * 20 + 52 : button_n * 20 + 62 , 70 ,
			20 , 20 ,
			hwnd , NULL , hInstance , NULL
		);
	}
	//pbh{^̃TuNX
	DefPadButtonProc = ( WNDPROC )GetWindowLong( hpadbutton[ 0 ] , GWL_WNDPROC );
	for(button_n=0;button_n<16;button_n++){
		SetWindowLong( hpadbutton[ button_n ] , GWL_WNDPROC , (LONG)PadButtonProc );
	}
	//M{^
	CreateWindow(
		TEXT( "BUTTON" ) , TEXT( "M" ) ,
		WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON ,
		423 , 20 ,
		100 , 50 ,
		hwnd , (HMENU)SEND_BUTTON_ID , hInstance , NULL
	);
	//Zbg{^
	CreateWindow(
		TEXT( "BUTTON" ) , TEXT( "Zbg" ) ,
		WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON ,
		423 , 80 ,
		100 , 50 ,
		hwnd , (HMENU)RESET_BUTTON_ID , hInstance , NULL
	);
	//XN[EBhẼNXo^
	winc.lpfnWndProc = ScrWndProc;
	winc.lpszClassName = TEXT( "classSCRWND" );
	if( !RegisterClass( &winc ) ) return -1;
	//XN[EBhE
	hscrwnd = CreateWindow(
		TEXT( "classSCRWND" ) , NULL ,
		WS_CHILD | WS_VISIBLE | WS_VSCROLL ,
		10 , 100 ,
		400 , 400 ,
		hwnd , NULL , hInstance , NULL
	);
	//XN[EBhE̔wi
	CreateWindow(
		TEXT( "STATIC" ) , NULL ,
		WS_CHILD | WS_VISIBLE ,
		0 , 0,
		400 , TOTAL_FRAME_N <= 20 ? 400 : TOTAL_FRAME_N  * 20 ,
		hscrwnd , NULL , hInstance , NULL
	);
	//t[ԍ
	for(frame_n=0;frame_n<TOTAL_FRAME_N;frame_n++){
		wsprintf( &str , "%d" , frame_n + 1 );
		CreateWindow(
			TEXT( "STATIC" ) , TEXT( &str ) ,
			WS_CHILD | WS_VISIBLE | SS_RIGHT ,
			0 , frame_n * 20 ,
			30 , 20 ,
			hscrwnd , NULL , hInstance , NULL
		);
	}
	//`FbN{bNX
	for(frame_n=0;frame_n<TOTAL_FRAME_N;frame_n++){
		for(button_n=0;button_n<16;button_n++){
			hcheck[ frame_n ][ button_n ] = CreateWindow(
				TEXT( "BUTTON" ) , NULL ,
				WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX ,
				button_n < 8 ? button_n * 20 + 45 : button_n * 20 + 55 , frame_n * 20 ,
				20 , 20 ,
				hscrwnd , NULL , hInstance , NULL
			);
		}
	}
	//XN[o[̏`
	SendMessage( hscrwnd , WM_VSCROLL , 0 , 0 );
	//bZ[W[v
	while( GetMessage( &msg , NULL , 0 , 0 ) ){
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	return msg.wParam;
}